package de._82grfl1bif.KPI_Visualizer.layouts.TreeMap;

import de._82grfl1bif.KPI_Visualizer.structures.Structure;

import java.awt.*;
import java.util.ArrayList;
import java.util.HashMap;

public class Rectangle{

    private double area;
    private double width;
    private double height;
    private Point origin;

    public void setHeight(double height) {
        this.height = height;
        this.width = area/height;
    }

    public void setWidth(double width) {
        this.width = width;
        this.height = area/width;
    }

    public double getArea() {
        return area;
    }

    public double getWidth() {
        return width;
    }

    public double getHeight() {
        return height;
    }

    public Point getOrigin() {
        return origin;
    }

    public void setOrigin(Point origin) {
        this.origin = origin;
    }

    public Rectangle(double area,double width,Point origin){
        this.area = area;
        this.origin = origin;
        setWidth(width);
    }

    public double getSideRelation(){
        return Math.max(width/height,height/width);
    }

    public boolean checkSideRelation(double side){
        return !(getSideRelation() < Math.max((area/side)/side,side/(area/side)));// false if the Relation gets worse.
    }


}
