package de._82grfl1bif.KPI_Visualizer.structures;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.util.Vector;

import javax.persistence.Column;
import javax.persistence.Entity;
import java.awt.*;

public abstract class Structure{

    protected Point width = new Point(0,0);
    protected Material material;
    protected Location location;
    protected int depth;
    protected String name;
    protected double area;

    public double getArea() {
        return area;
    }

    public Material getMaterial() {
        return material;
    }

    public Location getLocation() {
        return location;
    }

    public void setLocation(Location location) {
        this.location = location;
    }

    public void addVector(Vector vector){
        this.location.add(vector);
    }

    public Point getWidth() {
        return width;
    }

    public void setDepth(int depth) {
        this.depth = depth;
    }

    public int getDepth() {
        return depth;
    }

    public abstract Structure getFromTree(String checkName);
}
